-- Lua Library inline imports
local function __TS__ArrayForEach(self, callbackFn, thisArg)
    for i = 1, #self do
        callbackFn(thisArg, self[i], i - 1, self)
    end
end
-- End of Lua Library inline imports
world = world or ({})
do
    minetest.register_alias("mapgen_stone", "stone")
    minetest.register_alias("mapgen_dirt", "dirt")
    minetest.register_alias("mapgen_dirt_with_grass", "grass")
    minetest.register_alias("mapgen_sand", "sand")
    minetest.register_alias("mapgen_gravel", "gravel")
    minetest.register_biome({
        name = "Forgotten Fields",
        node_top = "grass",
        depth_top = 1,
        node_filler = "dirt",
        depth_filler = 6,
        node_stone = "stone"
    })
    do
        local grass = {}
        do
            local i = 1
            while i <= 5 do
                local height = tostring(i)
                table.insert(grass, "tall_grass_" .. height)
                i = i + 1
            end
        end
        minetest.register_decoration({
            name = "grassOnFields",
            deco_type = DecorationType.simple,
            place_on = "grass",
            biomes = {"Forgotten Fields"},
            decoration = grass,
            param2 = 0,
            param2_max = 239,
            fill_ratio = 0.98
        })
        local concat = utility.concat
        local generateSchematic = utility.generateSchematic
        local create = vector.create
        local smallOak = generateSchematic(
            create(5, 5, 5),
            {[" "] = "air", I = "oak_tree", H = "oak_leaves"},
            {I = true},
            concat(
                "     ",
                "     ",
                "  H  ",
                " HHH ",
                "     ",
                "     ",
                "  H  ",
                " HHH ",
                "HHHHH",
                "     ",
                "  H  ",
                " HHH ",
                "HHIHH",
                "HHIHH",
                "  I  ",
                "     ",
                "  H  ",
                " HHH ",
                "HHHHH",
                "     ",
                "     ",
                "     ",
                "  H  ",
                " HHH ",
                "     "
            ),
            {
                253,
                253,
                253,
                253,
                253,
                253,
                254,
                254,
                254,
                253,
                253,
                254,
                255,
                254,
                253,
                253,
                254,
                254,
                254,
                253,
                253,
                253,
                253,
                253,
                253
            }
        )
        local mediumOak = generateSchematic(
            create(7, 7, 7),
            {[" "] = "air", I = "oak_tree", H = "oak_leaves"},
            {I = true},
            concat(
                "       ",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                "       ",
                "       ",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                " HHHHH ",
                "       ",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                " HHHHH ",
                "HHHHHHH",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                " HHIHH ",
                "HHHIHHH",
                "HHHIHHH",
                "   I   ",
                "   I   ",
                "       ",
                "   H   ",
                "  HHH  ",
                " HHHHH ",
                "HHHHHHH",
                "       ",
                "       ",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                " HHHHH ",
                "       ",
                "       ",
                "       ",
                "       ",
                "       ",
                "   H   ",
                "  HHH  ",
                "       ",
                "       "
            ),
            {
                252,
                252,
                252,
                252,
                252,
                252,
                252,
                252,
                253,
                253,
                253,
                253,
                253,
                252,
                252,
                253,
                254,
                254,
                254,
                253,
                252,
                252,
                253,
                254,
                255,
                254,
                253,
                252,
                252,
                253,
                254,
                254,
                254,
                253,
                252,
                252,
                253,
                253,
                253,
                253,
                253,
                252,
                252,
                252,
                252,
                252,
                252,
                252,
                252
            }
        )
        local largeOak = generateSchematic(
            create(9, 9, 9),
            {[" "] = "air", I = "oak_tree", H = "oak_leaves"},
            {I = true},
            concat(
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "   HHH   ",
                "         ",
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                "  HHHHH  ",
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                " HHHHHHH ",
                " HHHHHHH ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                " HHHHHHH ",
                "HHHHHHHHH",
                "HHHHHHHHH",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHIHH  ",
                " HHHIHHH ",
                "HHHHIHHHH",
                "HHHHIHHHH",
                "HHHHIHHHH",
                "    I    ",
                "    I    ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                " HHHHHHH ",
                "HHHHHHHHH",
                "HHHHHHHHH",
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                " HHHHHHH ",
                " HHHHHHH ",
                "         ",
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "  HHHHH  ",
                "  HHHHH  ",
                "         ",
                "         ",
                "         ",
                "         ",
                "         ",
                "         ",
                "    H    ",
                "   HHH   ",
                "   HHH   ",
                "         ",
                "         "
            ),
            {
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                252,
                252,
                252,
                252,
                252,
                252,
                252,
                251,
                251,
                252,
                253,
                253,
                253,
                253,
                253,
                252,
                251,
                251,
                252,
                253,
                254,
                254,
                254,
                253,
                252,
                251,
                251,
                252,
                253,
                254,
                255,
                254,
                253,
                252,
                251,
                251,
                252,
                253,
                254,
                254,
                254,
                253,
                252,
                251,
                251,
                252,
                253,
                253,
                253,
                253,
                253,
                252,
                251,
                251,
                252,
                252,
                252,
                252,
                252,
                252,
                252,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251,
                251
            }
        )
        do
            local smallID = minetest.register_schematic(smallOak)
            local mediumID = minetest.register_schematic(mediumOak)
            local largeID = minetest.register_schematic(largeOak)
            local oakSize = {"small", "medium", "large"}
            local oakIDs = {smallID, mediumID, largeID}
            __TS__ArrayForEach(
                oakIDs,
                function(____, id, key)
                    minetest.register_decoration({
                        name = "oak_" .. oakSize[key + 1],
                        deco_type = DecorationType.schematic,
                        place_on = "grass",
                        biomes = {"Forgotten Fields"},
                        schematic = id,
                        fill_ratio = 0.01,
                        place_offset_y = 1,
                        flags = "place_center_x, place_center_z"
                    })
                end
            )
        end
    end
    utility.loadFiles({"ores"})
end
